# hamiltonian.mod

param n integer, > 0;
set V := 1..n;
set E within {V,V};
set A := E union {i in V, j in V : (j,i) in E};

var x{A} binary;

#maximize hamiltonian: sum{(i,j) in A} x[i,j];

subject to successor{i in V} :
  sum{j in V : (i,j) in A} x[i,j] = 1;
subject to predecessor{j in V} :
  sum{i in V : (i,j) in A} x[i,j] = 1;

subject to singleton{i in V} :
  sum{j in V : i!=j and (i,j) in A} x[i,j] >= 1;

subject to pairs{i in V, j in V : i<j} :
  sum{k in V : k not in {i,j} and (i,k) in A} x[i,k] +
  sum{k in V : k not in {i,j} and (j,k) in A} x[j,k] >= 1;

